#include <stdio.h>
#include <malloc.h>
#include "sage++user.h"

#define MY_ATTRIBUTE_TYPE1 10
#define MY_ATTRIBUTE_TYPE2 20


int main(int argc, char **argv){

// better to grab the names from argv.
// but lets keep it simple.

  SgProject myproject("test", argc, argv);

  printf("the file name is %s\n", myproject.fileName(0));

  // SgFile file(project.fileName(1));
  
 

  SgFile * file;
  SgStatement * first;
  SgStatement * temp;
  
  char * str;

  SgProject * project;
  
  project = &myproject;

      int nbfile = project->numberOfFiles();

      int i, j;

      for (i=0; i< nbfile; i++)
        {
          file = &(project->file(i));
          first =   file->firstStatement();
          temp = first;
          while (temp)
            {
              str = new char[256];
              sprintf(str,"this_is_an_attribute_added_statement_line_%d",
                      temp->lineNumber());
              temp->addAttribute(MY_ATTRIBUTE_TYPE1,(void *) str, strlen(str));
              temp = temp->lexNext();
            }
        }

      for (i=0; i< nbfile; i++)
        {
          file = &(project->file(i));
          first =   file->firstStatement();
          temp = first;
          while (temp)
            {
              str = new char[256];
              sprintf(str,"this_is_an_attribute_added_statement_line_%d",
                      temp->lineNumber());
              temp->addAttribute(MY_ATTRIBUTE_TYPE2,(void *) str, strlen(str));
              temp = temp->lexNext();
            }
        }



      for (i=0; i< nbfile; i++)
        {
          file = &(project->file(i));
          first =   file->firstStatement();
          temp = first;
          while (temp)
            {
              for (j=0; j< temp->numberOfAttributes(); j++)
                printf("Found attribute type %d ---> %s\n",
                       temp->attributeType(j),
                       (char *) temp->attributeValue(j));
              temp = temp->lexNext();
            }
        }

      file->saveDepFile("att.dep");

      SgAttribute * att;

      int nba = file->numberOfAttributes();
      for (i=0 ; i< nba; i++)
        {
          att = file->attribute(i);
	  printf("Found attribute from file type %d ---> %s\n",
                       att->getAttributeType(),
                       (char *) att->getAttributeData());

        };



  return 0;
}

